import md5 from 'blueimp-md5'
import { fetchEventSource } from '@microsoft/fetch-event-source'
import { fetchAgents } from '@/api/chat'

export function useChat() {
  const authKey = 'f3846153ba784b6d86bdcd5533259c88'
  const authSecret = 'HO4IyLEwEOHpeOXBxaLQUOqWslJRGs1M'

  const messages = ref([])
  const chatId = ref(null)

  async function post(data) {
    const timestamp = Date.now()
    const sign = md5(`${authKey}${authSecret}${timestamp}`)
    await fetchEventSource('/api/ai/openapi/agent/chat/stream/v1', {
      method: 'POST',
      headers: { authKey, timestamp, sign, 'Content-Type': 'application/json' },
      body: JSON.stringify({ ...data, chatId: chatId.value, agentId: 'f3846153ba784b6d86bdcd5533259c88' }),
      async onopen(response) {
        if (response.ok) {
          return response
        } else {
          throw response
        }
      },
      onmessage(res) {
        console.log(res.data)
        const message = JSON.parse(res.data)
        chatId.value = message.chatId
        const conversationId = message.conversationId
        const messageIndex = messages.value.findIndex(session => session.conversationId === conversationId)
        let content = message.content || ''
        if (message.content === '\n') content = '<br/>'
        if (messageIndex === -1) {
          messages.value.push({ conversationId, role: 'bot', content })
        } else {
          messages.value[messageIndex].content = messages.value[messageIndex].content + content
        }
      },
      onerror(err) {
        throw err
      }
    })
  }

  async function getAgents() {
    await fetchAgents()
  }

  return { chatId, messages, post, getAgents }
}
